local LDB
local parent = CreateFrame('Frame')

 -- Get a reference to the lib
local LibQTip = LibStub('LibQTip-1.0')
local tooltip = nil
local tooltip2 = nil

local function UpdateDisplay()
	if lastmountIndex ~= nil then
		LDB.text = lastmountText
		LDB.icon = lastmountIcon
		local creatureID, creatureName, creatureSpellID, icon, issummoned, mounttype = GetCompanionInfo("MOUNT", lastmountIndex) -- check to see if a new companion was learned and moved the index of the last
		if creatureName ~= lastmountText then
			for i = 1, GetNumCompanions("MOUNT") do
			local creatureID, creatureName, creatureSpellID, icon, issummoned, mounttype = GetCompanionInfo("MOUNT", i)
			if creatureName == lastmountText then
				lastmountIndex = i
			end
			end
		end
	end
	
	if favmount1index ~= nil  then
		local creatureID, creatureName, creatureSpellID, icon, issummoned, mounttype = GetCompanionInfo("MOUNT", favmount1index)
		if creatureName ~= favmount1name then
			for i = 1, GetNumCompanions("MOUNT") do
			local creatureID, creatureName, creatureSpellID, icon, issummoned, mounttype = GetCompanionInfo("MOUNT", i)
			if creatureName == favmount1name then
				favmount1index = i
			end
			end
		end
	end
	if favmount2index ~= nil  then
		local creatureID, creatureName, creatureSpellID, icon, issummoned, mounttype = GetCompanionInfo("MOUNT", favmount2index)
		if creatureName ~= favmount2name then
			for i = 1, GetNumCompanions("MOUNT") do
			local creatureID, creatureName, creatureSpellID, icon, issummoned, mounttype = GetCompanionInfo("MOUNT", i)
			if creatureName == favmount2name then
				favmount2index = i
			end
			end
		end
	end
	if favmount3index ~= nil  then
		local creatureID, creatureName, creatureSpellID, icon, issummoned, mounttype = GetCompanionInfo("MOUNT", favmount3index)
		if creatureName ~= favmount3name then
			for i = 1, GetNumCompanions("MOUNT") do
			local creatureID, creatureName, creatureSpellID, icon, issummoned, mounttype = GetCompanionInfo("MOUNT", i)
			if creatureName == favmount3name then
				favmount3index = i
			end
			end
		end
	end
	
	for i = 1, GetNumCompanions("MOUNT") do
	local creatureID, creatureName, creatureSpellID, icon, issummoned, mounttype = GetCompanionInfo("MOUNT", i)
		if issummoned then
			LDB.text = creatureName
			LDB.icon = icon
			lastmountIcon = icon
			lastmountIndex = i
			lastmountSpell = creatureSpellID
			lastmountText = creatureName
			return
		end
		if lastmountSpell ~= nil and lastmountText ~= nil then
		local isUsable, notEnoughMana = IsUsableSpell(lastmountSpell)
			if isUsable then
				LDB.text = lastmountText
			else
				LDB.text = string.format('|cff848484%s|r', lastmountText)
			end
		end
	end
end

local function ModifiedClick(button, i)	
local creatureID, creatureName, creatureSpellID, icon, issummoned, mounttype = GetCompanionInfo("MOUNT", i)
	if IsShiftKeyDown() then
		PickupCompanion("MOUNT", i)
	elseif IsAltKeyDown()and not IsControlKeyDown()  then
		favmount1index = i
		favmount1name = creatureName
		favmount1icon = icon
		DEFAULT_CHAT_FRAME:AddMessage(string.format("|cffffff00BrokerMounts:|r %s added as favorite 1.", creatureName))
	elseif IsControlKeyDown() and not IsAltKeyDown() then
		favmount2index = i
		favmount2name = creatureName
		favmount2icon = icon
		DEFAULT_CHAT_FRAME:AddMessage(string.format("|cffffff00BrokerMounts:|r %s added as favorite 2.", creatureName))
	elseif IsControlKeyDown() and IsAltKeyDown() then
		favmount3index = i
		favmount3name = creatureName
		favmount3icon = icon
		DEFAULT_CHAT_FRAME:AddMessage(string.format("|cffffff00BrokerMounts:|r %s added as favorite 3.", creatureName))
	else
		CallCompanion("MOUNT", i)
	end
	LibQTip:Release(tooltip)
	tooltip = nil
end

local function OnEnter(self)	
   -- Acquire a tooltip with 1 columns, aligned to left
tooltip2 = LibQTip:Acquire("BrokerMountsTooltip2", 1, "LEFT") 
self.tooltip2 = tooltip2
  
   -- Use smart anchoring code to anchor the tooltip to our frame
tooltip2:SmartAnchorTo(self)
tooltip2:Clear()   

	tooltip2:AddHeader('|cff00ffffBrokerMounts|r')
	tooltip2:AddLine("|cffffff00<Right Click>|r to open mount list")
	tooltip2:AddLine("|cffffff00<Left Click>|r to mount/dismount")
	tooltip2:AddLine("|cffffff00<Shift-Left Click>|r plugin to open mount journal")
	tooltip2:AddLine("|cffffff00<Shift-Left Click>|r on mount to pick it up")
	if favmount1index then
	tooltip2:AddLine(format("|cffffff00<ALT-Click>|r |T%s:16|t%s", favmount1icon, favmount1name))
	else
	tooltip2:AddLine("|cffffff00<ALT-Click>|r mount to set as favorite 1")
	end
	if favmount2index then
	tooltip2:AddLine(format("|cffffff00<CTRL-Click>|r |T%s:16|t%s", favmount2icon, favmount2name))
	else
	tooltip2:AddLine("|cffffff00<CTRL-Click>|r mount to set as favorite 2")
	end
	if favmount3index then
	tooltip2:AddLine(format("|cffffff00<CTRL-ALT-Click>|r |T%s:16|t%s", favmount3icon, favmount3name))
	else
	tooltip2:AddLine("|cffffff00<CTRL-ALT-Click>|r mount to set as favorite 3")
	end
	if GetNumCompanions("MOUNT") == 0 then
	tooltip2:AddLine("|cffff0000You have no mounts|r")
	else
	tooltip2:AddLine(string.format("|cff00ff00You have %s mounts|r", GetNumCompanions("MOUNT")))
	end
	 -- Show it
	if tooltip and tooltip:IsShown() then
		LibQTip:Release(self.tooltip2)
		self.tooltip2 = nil
	else
		tooltip2:Show()
	end
end



local function CreateMountTooltip(self)  
   -- Acquire a tooltip with 1 columns, aligned to left
tooltip = LibQTip:Acquire("BrokerMountsTooltip", 1, "LEFT") 
self.tooltip = tooltip 
tooltip:EnableMouse(true)
tooltip:SetAutoHideDelay(1, self)
  
   -- Use smart anchoring code to anchor the tooltip to our frame
tooltip:SmartAnchorTo(self)
tooltip:Clear() 
   
	for i = 1, GetNumCompanions("MOUNT") do
		local creatureID, creatureName, creatureSpellID, icon, issummoned, mounttype = GetCompanionInfo("MOUNT", i)
		local isUsable, notEnoughMana = IsUsableSpell(creatureSpellID)
		local MountFlag
		if bit.band(mounttype, 0x02 ) ==  0x02 then --Flying
			MountFlag = "|cff4d9cdf(F)|r"
		elseif  bit.band(mounttype, 0x01 ) ==  0x01 then --Ground
			MountFlag = "|cffaa6641(G)|r"
		else
			MountFlag = "|cff00ffff(A)|r"
		end
		 -- Add an new line, using all columns
		if isUsable then
			if issummoned then
				tooltip:AddLine(format("|T%s:16|t |cff00ff00%s %s|r", icon, creatureName, MountFlag))
				tooltip:SetCellScript(i, 1, "OnMouseUp", ModifiedClick, i)
			else
				tooltip:AddLine(format("|T%s:16|t %s %s", icon, creatureName, MountFlag))
				tooltip:SetCellScript(i, 1, "OnMouseUp", ModifiedClick, i)
			end
		else
			tooltip:AddLine(format("|T%s:16|t |cff848484%s %s|r", icon, creatureName, MountFlag))
			tooltip:SetCellScript(i, 1, "OnMouseUp", ModifiedClick, i)
		end	
	end
   tooltip:UpdateScrolling(500)
   -- Show it
	if tooltip:IsShown() then
		LibQTip:Release(self.tooltip)
		self.tooltip = nil	
	else
		tooltip:Show()
		LibQTip:Release(self.tooltip2)
		tooltip2 = nil
	end
end
 
local function OnLeave(self)  
   -- Release the tooltip
   LibQTip:Release(self.tooltip2)
   self.tooltip2 = nil 
   
end
 
local function OnClick(self, button)
	if button == 'RightButton' then
		CreateMountTooltip(self)
	end
	if (button == 'LeftButton' and not IsShiftKeyDown() and not IsAltKeyDown() and not IsControlKeyDown()) then
		if IsMounted() then
			Dismount()
		elseif lastmountIndex ~= nil then
			CallCompanion("MOUNT", lastmountIndex)
		end
	elseif (IsShiftKeyDown() and button == 'LeftButton') then	
		TogglePetJournal(1)	
	elseif (button == 'LeftButton' and IsAltKeyDown() and not IsControlKeyDown()) then
		if favmount1index ~= nil then
			CallCompanion("MOUNT", favmount1index)
		end
	elseif (button == 'LeftButton' and IsControlKeyDown() and not IsAltKeyDown()) then
		if favmount2index ~= nil then
			CallCompanion("MOUNT", favmount2index)
		end
	elseif (button == 'LeftButton' and IsControlKeyDown() and IsAltKeyDown()) then
		if favmount3index ~= nil then
			CallCompanion("MOUNT", favmount3index)
		end
	end
end

function parent:PLAYER_LOGIN()
	LDB = LibStub('LibDataBroker-1.1'):NewDataObject('BrokerMounts', {
		icon = "Interface\\Icons\\INV_Misc_QuestionMark.blp",
		text = "BrokerMounts",
		type = 'data source',
		--OnTooltipShow = OnTooltipShow,
		OnEnter = OnEnter,
		OnLeave = OnLeave,
		OnClick = OnClick,
	})
	self:RegisterEvent('SPELL_UPDATE_USABLE')
	self:RegisterEvent('COMPANION_UPDATE')
	self.COMPANION_UPDATE = UpdateDisplay
	self.SPELL_UPDATE_USABLE = UpdateDisplay
	
	UpdateDisplay()
end

 -- Somewhere in the anchor initialization
parent:SetScript('OnEnter', OnEnter)
parent:SetScript('OnLeave', OnLeave)
parent:SetScript('OnEvent', function(self, event, ...) self[event](self, ...) end)
parent:RegisterEvent('PLAYER_LOGIN')